include masm32rt.inc

include msimg32.inc
includelib Msimg32.lib
.686p
.mmx
.xmm

WM_TOOL_CHANGE 		EQU (WM_USER+1)		; wParam = new mode
WM_COLOR1_CHANGE	EQU (WM_USER+2)		; wParam = COLORREF
WM_COLOR2_CHANGE	EQU (WM_USER+3)		; wParam = COLORREF
WM_CHILD_DESTROY	EQU (WM_USER+4)		; wParam = hWndMdi
WM_SET_MDI_OWNER	EQU (WM_USER+5)		; wParam = hOwner


WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
CreateImageList proto hWnd:HWND,hIml:HIMAGELIST
CreateMainControls  proto hWnd:DWORD

PARAM_CREATE        equ      0
NoTBDrawButtons     equ      3
NoTBPenButtons      equ      3    
NoImages            equ      6

TBDrawID            equ      100h
TBPenID             equ      200h

MODE_PEN	EQU 1
MODE_LINE	EQU 2
MODE_RECT	EQU 4
MODE_ELLIPS	EQU 8

PHWND typedef ptr HWND

IDRB_PEN	EQU 10
IDRB_LINE	EQU 11
IDRB_RECT	EQU 12
IDRB_ELLIPS	EQU 13
IDBTN_CC1	EQU 14
IDBTN_CC2	EQU 15
IDBTN_NEW	EQU 16

WND_DATA struct
	hRBHorz		HWND		?
	hIml		HIMAGELIST	?
	hTbTools	HWND		?
	mode		HWND		?
	hMdiClient	HWND		?
	nMdiChilds	DWORD		?
	pMdiChilds	PHWND		?
WND_DATA ends

MDI_CHILD struct
	hOwner		HWND		?
	hdc			HDC			?	; for double buffering
	hdcDrawing	HDC			?	; current drawing
	hdcLayer	HDC			?	; used for preview (rectangle, ellips,...)
	clrTransp	COLORREF	?	; transaprent color, used for merging hdcDrawing and hdcLayer
	hPen		HPEN		?
	hBrush		HBRUSH		?
	drag		DWORD		?
	mode		DWORD		?
	ptDown		POINT		<>
MDI_CHILD ends


.data
TBTools		    TBBUTTON    <6,IDBTN_NEW,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
				TBBUTTON    <0,IDRB_PEN,TBSTATE_ENABLED or TBSTATE_CHECKED,BTNS_CHECKGROUP,NULL,NULL>                
                TBBUTTON    <1,IDRB_LINE,TBSTATE_ENABLED,BTNS_CHECKGROUP,NULL,NULL>
                TBBUTTON    <2,IDRB_RECT,TBSTATE_ENABLED,BTNS_CHECKGROUP,NULL,NULL>
                TBBUTTON    <3,IDRB_ELLIPS,TBSTATE_ENABLED,BTNS_CHECKGROUP,NULL,NULL>
                TBBUTTON    <4,IDBTN_CC1,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <5,IDBTN_CC2,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>

             	align 4
ColorArray    	dd 00000000h,00aa0000h,0000aa00h,00aaaa00h
              	dd 000000aah,00aa00aah,000055aah,00aaaaaah
              	dd 00555555h,00ff5555h,0055ff55h,00ffff55h
              	dd 005555ffh,00ff55ffh,0055ffffh,00ffffffh

ChooseColorName db 'Choose Color',0
ccStruct		CHOOSECOLOR     <sizeof CHOOSECOLOR,?,?,80h,offset ColorArray,0,0,0,0>    
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG

	mov wcex.hInstance,rv(GetModuleHandle,0)
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,SIZEOF WND_DATA
	mov wcex.hbrBackground,rv(GetStockObject,WHITE_BRUSH)
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("some class name")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,NULL,wcex.lpszClassName,"xyz",WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,wcex.hInstance,NULL)
	invoke ShowWindow,esi,SW_SHOWNORMAL
	invoke UpdateWindow,esi

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw

	invoke ExitProcess,msg.wParam

main endp

MdiBroadcastMessage proc uses edi esi ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov ebx,rv(GetWindowLong,hWnd,WND_DATA.pMdiChilds)
	mov edi,rv(GetWindowLong,hWnd,WND_DATA.nMdiChilds)
	xor esi,esi
	.while esi < edi
		invoke SendMessage,HWND ptr [ebx+esi*4],uMsg,wParam,lParam
		lea esi,[esi+1]
	.endw
	ret
MdiBroadcastMessage endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
		free rv(GetWindowLong,hWnd,WND_DATA.pMdiChilds)
	.elseif uMsg == WM_CREATE
		invoke SetWindowLong,hWnd,WND_DATA.mode,MODE_PEN
		invoke CreateMainControls,hWnd
    .elseif uMsg == WM_COMMAND
        .if  lParam == rv(GetWindowLong,hWnd,WND_DATA.hTbTools)
            .if WORD ptr wParam == IDBTN_CC1
	            .if rv(ChooseColor,addr ccStruct)
	            	invoke MdiBroadcastMessage,hWnd,WM_COLOR1_CHANGE,ccStruct.rgbResult,0
	            .endif
            .elseif WORD ptr wParam == IDBTN_CC2
	            .if rv(ChooseColor,addr ccStruct)
	            	invoke MdiBroadcastMessage,hWnd,WM_COLOR2_CHANGE,ccStruct.rgbResult,0
	            .endif
            .elseif WORD ptr wParam == IDRB_PEN
            	invoke MdiBroadcastMessage,hWnd,WM_TOOL_CHANGE,MODE_PEN,0
            	invoke SetWindowLong,hWnd,WND_DATA.mode,MODE_PEN
            .elseif WORD ptr wParam == IDRB_LINE
            	invoke MdiBroadcastMessage,hWnd,WM_TOOL_CHANGE,MODE_LINE,0
            	invoke SetWindowLong,hWnd,WND_DATA.mode,MODE_LINE
            .elseif WORD ptr wParam == IDRB_RECT
            	invoke MdiBroadcastMessage,hWnd,WM_TOOL_CHANGE,MODE_RECT,0
            	invoke SetWindowLong,hWnd,WND_DATA.mode,MODE_RECT
            .elseif WORD ptr wParam == IDRB_ELLIPS
            	invoke MdiBroadcastMessage,hWnd,WM_TOOL_CHANGE,MODE_ELLIPS,0
            	invoke SetWindowLong,hWnd,WND_DATA.mode,MODE_ELLIPS
            .elseif WORD ptr wParam == IDBTN_NEW
            	mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hMdiClient)
            	mov edi,rv(CreateWindowEx,WS_EX_MDICHILD,"MdiChild","Untitled",MDIS_ALLCHILDSTYLES,CW_USEDEFAULT,CW_USEDEFAULT,300,200,ebx,0,rv(GetWindowLong,hWnd,GWL_HINSTANCE),0)
            	invoke SendMessage,edi,WM_TOOL_CHANGE,rv(GetWindowLong,hWnd,WND_DATA.mode),0
            	mov ebx,rv(GetWindowLong,hWnd,WND_DATA.pMdiChilds)
            	mov esi,rv(GetWindowLong,hWnd,WND_DATA.nMdiChilds)
            	.if esi != 0
            		mov ebx,rv(GlobalReAlloc,ebx,ADDR [esi*4+4],GMEM_MOVEABLE)
            	.else
            		mov ebx,alloc(4)
            	.endif
            	mov DWORD ptr [ebx+esi*4],edi
            	invoke SetWindowLong,hWnd,WND_DATA.nMdiChilds,ADDR [esi+1]
            	invoke SetWindowLong,hWnd,WND_DATA.pMdiChilds,ebx
            .endif
        .endif    
	.elseif uMsg == WM_CHILD_DESTROY
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.pMdiChilds)
		mov esi,rv(GetWindowLong,hWnd,WND_DATA.nMdiChilds)
		.if esi == 1
            free ebx
            invoke SetWindowLong,hWnd,WND_DATA.nMdiChilds,0
            invoke SetWindowLong,hWnd,WND_DATA.pMdiChilds,0
		.else
			mov edi,alloc(ADDR [esi-1])
			xor ecx,ecx
			xor edx,edx
			.while ecx < esi
				mov eax,HWND ptr [ebx+ecx*4]
				.if eax != wParam
					mov HWND ptr [edi+edx*4],eax
					lea edx,[edx+1]
				.endif
				lea ecx,[ecx+1]
			.endw
			free ebx
            invoke SetWindowLong,hWnd,WND_DATA.nMdiChilds,ADDR [esi-1]
            invoke SetWindowLong,hWnd,WND_DATA.pMdiChilds,edi
		.endif 
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp

MdiProc PROC uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
local ps:PAINTSTRUCT
local hBmp:HBITMAP
local hx:DWORD
LOCAL rect:RECT
LOCAL hDC:HDC
LOCAL pt[2]:POINT
LOCAL mode:DWORD
LOCAL _size:_SIZE
       
    .if uMsg == WM_MDIDESTROY
        invoke  SendMessage,hWnd,WM_SYSCOMMAND,SC_CLOSE,NULL
        invoke DeleteObject,rv(GetWindowLong,hWnd,MDI_CHILD.hdc)
        invoke DeleteObject,rv(GetWindowLong,hWnd,MDI_CHILD.hdcDrawing)
        invoke DeleteObject,rv(GetWindowLong,hWnd,MDI_CHILD.hdcLayer)
        invoke DeleteObject,rv(GetWindowLong,hWnd,MDI_CHILD.hPen)
        invoke DeleteObject,rv(GetWindowLong,hWnd,MDI_CHILD.hBrush)
        invoke SendMessage,rv(GetWindowLong,hWnd,MDI_CHILD.hOwner),WM_CHILD_DESTROY,hWnd,0
    .elseif uMsg==WM_CREATE
		
		mov esi,rv(GetDC,rv(GetDesktopWindow))
		mov ebx,rv(CreateCompatibleDC,esi)
		mov edi,rv(GetSystemMetrics,SM_CXSCREEN)
		invoke DeleteObject,rv(SelectObject,ebx,rv(CreateCompatibleBitmap,esi,edi,rv(GetSystemMetrics,SM_CYSCREEN)))
		invoke ReleaseDC,rv(GetDesktopWindow),esi
		invoke SetWindowLong,hWnd,MDI_CHILD.hdc,ebx
        invoke  BitBlt,ebx,0,0,10000,10000,ebx,0,0,PATCOPY
 		
		mov esi,rv(GetDC,rv(GetDesktopWindow))
		mov ebx,rv(CreateCompatibleDC,esi)
		mov edi,rv(GetSystemMetrics,SM_CXSCREEN)
		invoke DeleteObject,rv(SelectObject,ebx,rv(CreateCompatibleBitmap,esi,edi,rv(GetSystemMetrics,SM_CYSCREEN)))
		invoke ReleaseDC,rv(GetDesktopWindow),esi
		invoke SetWindowLong,hWnd,MDI_CHILD.hdcDrawing,ebx
        invoke  BitBlt,ebx,0,0,10000,10000,ebx,0,0,PATCOPY 		
 		
		mov esi,rv(GetDC,rv(GetDesktopWindow))
		mov ebx,rv(CreateCompatibleDC,esi)
		mov edi,rv(GetSystemMetrics,SM_CXSCREEN)
		invoke DeleteObject,rv(SelectObject,ebx,rv(CreateCompatibleBitmap,esi,edi,rv(GetSystemMetrics,SM_CYSCREEN)))
		invoke ReleaseDC,rv(GetDesktopWindow),esi
		invoke SetWindowLong,hWnd,MDI_CHILD.hdcLayer,ebx

        invoke SetWindowLong,hWnd,MDI_CHILD.clrTransp,0FF00FFh
        push rv(SelectObject,ebx,rv(CreateSolidBrush,0FF00FFh))
        invoke  BitBlt,ebx,0,0,10000,10000,ebx,0,0,PATCOPY 		
 		pop eax
 		invoke DeleteObject,rv(SelectObject,ebx,eax)
 		
 		invoke SetWindowLong,hWnd,MDI_CHILD.hPen,rv(CreatePen,PS_SOLID,4,0ff00h)
 		invoke SetWindowLong,hWnd,MDI_CHILD.hBrush,rv(CreateSolidBrush,0ff00h)
 		invoke SetWindowLong,hWnd,MDI_CHILD.mode,MODE_PEN
 		
    .elseif uMsg == WM_SET_MDI_OWNER
    	invoke SetWindowLong,hWnd,MDI_CHILD.hOwner,wParam
    .elseif uMsg == WM_TOOL_CHANGE
    	invoke SetWindowLong,hWnd,MDI_CHILD.mode,wParam
    .elseif uMsg == WM_COLOR1_CHANGE
    	invoke DeleteObject,rv(GetWindowLong,hWnd,MDI_CHILD.hPen)
 		invoke SetWindowLong,hWnd,MDI_CHILD.hPen,rv(CreatePen,PS_SOLID,4,wParam)
    .elseif uMsg == WM_COLOR2_CHANGE
    	invoke DeleteObject,rv(GetWindowLong,hWnd,MDI_CHILD.hBrush)
 		invoke SetWindowLong,hWnd,MDI_CHILD.hBrush,rv(CreateSolidBrush,wParam)
    .elseif uMsg==WM_PAINT
        invoke  BeginPaint,hWnd,addr ps
		mov ebx,rv(GetWindowLong,hWnd,MDI_CHILD.hdc)
		mov esi,rv(GetWindowLong,hWnd,MDI_CHILD.hdcDrawing)
		mov edi,rv(GetWindowLong,hWnd,MDI_CHILD.clrTransp)
		mov edx,ps.rcPaint.right
		sub edx,ps.rcPaint.left
		mov ecx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.top
		push edx
		push ecx
        invoke  BitBlt,ebx,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,esi,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
        mov esi,rv(GetWindowLong,hWnd,MDI_CHILD.hdcLayer)
        mov ecx,DWORD ptr [esp]
        mov edx,DWORD ptr [esp+4]
        invoke TransparentBlt,ebx,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,esi,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,edi
        pop ecx
        pop edx
        invoke  BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,ebx,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
        invoke  EndPaint,hWnd,addr ps
    .elseif uMsg==WM_LBUTTONDOWN
    	invoke SetCapture,hWnd
    	movzx eax,WORD ptr lParam
    	invoke SetWindowLong,hWnd,MDI_CHILD.ptDown.x,eax
    	movzx eax,WORD ptr lParam+2
    	invoke SetWindowLong,hWnd,MDI_CHILD.ptDown.y,eax
    	invoke SetWindowLong,hWnd,MDI_CHILD.drag,1
    .elseif uMsg == WM_LBUTTONUP
    	invoke ReleaseCapture
    	invoke SetWindowLong,hWnd,MDI_CHILD.drag,0
    	mov mode,rv(GetWindowLong,hWnd,MDI_CHILD.mode)
    	.if mode == MODE_LINE || mode  == MODE_RECT || mode == MODE_ELLIPS
    		mov ebx,rv(GetWindowLong,hWnd,MDI_CHILD.hdcDrawing)
    		mov esi,rv(GetWindowLong,hWnd,MDI_CHILD.hdcLayer)
    		mov edi,rv(GetWindowLong,hWnd,MDI_CHILD.clrTransp)
    		mov edx,rv(GetDesktopWindow)
			invoke GetClientRect,edx,ADDR rect
    		invoke TransparentBlt,ebx,0,0,rect.right,rect.bottom,esi,0,0,rect.right,rect.bottom,edi
    		invoke InvalidateRect,hWnd,0,0
    	.endif
    .elseif uMsg == WM_MOUSEMOVE
        .if rv(GetWindowLong,hWnd,MDI_CHILD.drag)
	        mov mode,rv(GetWindowLong,hWnd,MDI_CHILD.mode)
	        
	        mov pt[0].x,rv(GetWindowLong,hWnd,MDI_CHILD.ptDown.x)
	        mov pt[0].y,rv(GetWindowLong,hWnd,MDI_CHILD.ptDown.y)
	    	
	    	movzx eax,WORD ptr lParam
	    	mov pt[8].x,eax
	    	
	    	.if mode == MODE_PEN
	    		invoke SetWindowLong,hWnd,MDI_CHILD.ptDown.x,eax
	    	.endif
	    	movzx eax,WORD ptr lParam+2
	    	mov pt[8].y,eax
	    	
	    	.if mode == MODE_PEN
	    		invoke SetWindowLong,hWnd,MDI_CHILD.ptDown.y,eax
	    	.endif
	    	
	        .if mode == MODE_PEN
	        	mov ebx,rv(GetWindowLong,hWnd,MDI_CHILD.hdcDrawing)
	        .else
	        	mov ebx,rv(GetWindowLong,hWnd,MDI_CHILD.hdcLayer)
	        .endif
	        mov esi,rv(GetWindowLong,hWnd,MDI_CHILD.hPen)
	        mov edi,rv(GetWindowLong,hWnd,MDI_CHILD.hBrush)
	        mov esi,rv(SelectObject,ebx,esi)
	        mov edi,rv(SelectObject,ebx,edi)
	        
	        .if mode != MODE_PEN
		        push rv(SelectObject,ebx,rv(CreateSolidBrush,rv(GetWindowLong,hWnd,MDI_CHILD.clrTransp)))
		        invoke  BitBlt,ebx,0,0,10000,10000,ebx,0,0,PATCOPY 		
		 		pop eax
		 		invoke DeleteObject,rv(SelectObject,ebx,eax)
	        .endif
	        
	        .if mode == MODE_PEN || mode == MODE_LINE
	        	invoke MoveToEx,ebx,pt[0].x,pt[0].y,0
	        	invoke LineTo,ebx,pt[8].x,pt[8].y        	
	        .elseif mode == MODE_RECT
	        	invoke Rectangle,ebx,pt[0].x,pt[0].y,pt[8].x,pt[8].y
	        .elseif mode == MODE_ELLIPS
	        	invoke Ellipse,ebx,pt[0].x,pt[0].y,pt[8].x,pt[8].y
	        .endif
	        
	        invoke SelectObject,ebx,esi
	        invoke SelectObject,ebx,edi
	
	        invoke GetClientRect,hWnd,addr rect
	        invoke InvalidateRect,hWnd,addr rect,TRUE
	    .endif
    .else
        invoke  DefMDIChildProc,hWnd,uMsg,wParam,lParam
        ret
    .endif        
    xor eax,eax
    ret

MdiProc     endp   

CreateMainControls  PROC uses ebx edi esi hWnd:DWORD
LOCAL rbbi:REBARBANDINFO
LOCAL rect:RECT
LOCAL ccst:CLIENTCREATESTRUCT
LOCAL hInst:HINSTANCE
LOCAL wcex:WNDCLASSEX

	mov hInst,rv(GetWindowLong,hWnd,GWL_HINSTANCE)

; ++++ Rebar Controls Creation ++++

	mov edi,rv(CreateWindowEx,NULL,"ReBarWindow32",0,WS_VISIBLE or WS_CHILD or RBS_AUTOSIZE or WS_CLIPCHILDREN or WS_CLIPSIBLINGS,0,0,CW_USEDEFAULT,CW_USEDEFAULT,hWnd,0,hInst,0)
    invoke SetWindowLong,hWnd,WND_DATA.hRBHorz,edi
             

; ++++  ImageList Creation ++++

	mov esi,rv(ImageList_Create,20,20,ILC_COLOR32+ILC_MASK,6,6)
    invoke CreateImageList,hWnd,esi
    invoke SetWindowLong,hWnd,WND_DATA.hIml,esi

    invoke RtlZeroMemory,ADDR rbbi,SIZEOF rbbi
    mov     rbbi.cbSize,sizeof rbbi
    mov     rbbi.fMask,RBBIM_CHILD or RBBIM_SIZE or RBBIM_STYLE  or RBBIM_CHILDSIZE
    mov     rbbi.fStyle,RBBS_GRIPPERALWAYS or RBBS_TOPALIGN or RBBS_FIXEDSIZE
    m2m     rbbi.hwndChild,ebx
    mov     rbbi.lx,60
    mov     rbbi.cxMinChild,80
    mov     rbbi.cyMinChild,26
    mov     rbbi.cyChild,26
    mov     rbbi.cyIntegral,10
    mov     rbbi.lpText,chr$("GDI Example 1")
    invoke  SendMessage,edi,RB_INSERTBAND,0,addr rbbi

; ++++ tools Toolbar Creation ++++

    mov ebx,rv(CreateWindowEx,NULL,"ToolbarWindow32",NULL,WS_VISIBLE or WS_CHILD or TBSTYLE_FLAT or CCS_NODIVIDER or CCS_NOPARENTALIGN or CCS_NORESIZE,0,0,40,26,hWnd,TBPenID,hInst,0)      
    invoke SetWindowLong,hWnd,WND_DATA.hTbTools,ebx
    invoke  SendMessage,ebx,TB_SETIMAGELIST,0,esi
    invoke  SendMessage,eax,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0
    invoke  SendMessage,ebx,TB_ADDBUTTONS,7,addr TBTools
    invoke  SendMessage,ebx,TB_AUTOSIZE,0,0
    mov     rbbi.fStyle,RBBS_GRIPPERALWAYS
    mov     rbbi.hwndChild,ebx
    mov     rbbi.lx,80
    mov     rbbi.cxMinChild,80
    mov     rbbi.cyMinChild,26
    mov     rbbi.cyChild,26    
    mov     rbbi.cyIntegral,10    
    invoke  SendMessage,edi,RB_INSERTBAND,1,addr rbbi

; ++++ MDI Client Creation ++++
	mov edx,rv(GetDesktopWindow)
    invoke  GetClientRect,edx,addr rect
    invoke  SendMessage,edi,RB_GETBARHEIGHT,NULL,NULL
    add     eax,4
    sub     rect.bottom,eax
    add     rect.top,eax
   	mov ccst.hWindowMenu,0
   	mov ccst.idFirstChild,0
    mov ebx,rv(CreateWindowEx,0,"MDICLIENT",NULL,WS_VISIBLE or WS_CHILD,0,rect.top,rect.right,rect.bottom,hWnd,0300h,hInst,addr ccst)
   	invoke SetWindowLong,hWnd,WND_DATA.hMdiClient,ebx

	mov wcex.hInstance,rv(GetModuleHandle,0)
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET MdiProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,SIZEOF MDI_CHILD
	mov wcex.hbrBackground,0
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("MdiChild")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)

    invoke  RegisterClassEx,ADDR wcex 
    mov esi,rv(CreateWindowEx,WS_EX_MDICHILD,"MdiChild","Untitled",MDIS_ALLCHILDSTYLES,0,0,200,200,ebx,0,hInst,0)   
    mov ebx,alloc(SIZEOF HWND)
    mov HWND ptr [ebx],esi
    invoke SetWindowLong,hWnd,WND_DATA.pMdiChilds,ebx
    invoke SetWindowLong,hWnd,WND_DATA.nMdiChilds,1
    
    ret

CreateMainControls  endp

CreateImageList PROC uses edi esi ebx hWnd:HWND,hIml:HIMAGELIST
LOCAL hInst:HINSTANCE
LOCAL hBitmap:HBITMAP
LOCAL hBitmapMask:HBITMAP

	mov hInst,rv(GetWindowLong,hWnd,GWL_HINSTANCE)

    mov     esi,100
    mov     ecx,7
looper:    
    push    ecx
    invoke  LoadBitmap,hInst,esi
    mov     hBitmap,eax
    inc     esi
    invoke  LoadBitmap,hInst,esi
    mov     hBitmapMask,eax
    inc     esi
    invoke  ImageList_Add,hIml,hBitmap,eax
    invoke  DeleteObject,hBitmap
    invoke  DeleteObject,hBitmapMask
    pop     ecx
    dec     ecx
    jcxz    end_looper
    jmp     looper
end_looper:
    ret

CreateImageList endp    

end main
